$(function () {

	Init_translate();
	make_header("review");
	
$("#lbfromdate").text(DevExpress.localization.formatMessage("From date"));
$("#lbtodate").text(DevExpress.localization.formatMessage("To date"));
$("#lbplate").text(DevExpress.localization.formatMessage("Plate"));
$("#lblist").text(DevExpress.localization.formatMessage("List"));

	set_rcpopup();
	
	var priorities = [DevExpress.localization.formatMessage("All"), DevExpress.localization.formatMessage("In list"), DevExpress.localization.formatMessage("Not in list")];
	var sellist = 0;
	var dateact = new Date();
	var dateiniday;
	var dateendday ;
	var results = [];
	var dictlist = {};
	
	var dict = {};
	var listas=[];
	var d2;
	
	String.prototype.includes = function (str) {
		var returnValue = false;

		if (this.indexOf(str) !== -1) {
			returnValue = true;
		}

		return returnValue;
	}

	
	//GET TIME
	$.ajax({

		url: pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=gettime&dd"+ getStringNormalDate(new Date()),
		async: false,
		success: function (data) {

			d2 = new Date(data);
			dateiniday = new Date(d2.getFullYear(), d2.getMonth(), d2.getDate(), 0, 0, 0);
			dateendday = new Date(d2.getFullYear(), d2.getMonth(), d2.getDate(), 23, 59, 59);

		}
	});
	

	
	$.ajax({
		dataType: "json",
		url: pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=getconfig&dd"+ getStringNormalDate(new Date()),
		async: false,
		success: function (data) {
			
		
			
			$.each(data[1], function (i, item) {

				dict[item.id] = item.description;
				
			});
			
			var initelem = {};
			initelem["ID"]=-2;
			initelem["description"]=DevExpress.localization.formatMessage("All");
			listas.push(initelem);
			
			$.each(data[0], function (i, item) {
				var elem = {};
				elem["ID"]=item.id;
				elem["description"]=item.description;
				listas.push(elem);
			
				dictlist["["+item.id+"]"] = item.description;
			});

		}
	});
	
	

	var fdata1 = $("#data1").dxDateBox({
			type: "datetime",
			displayFormat: "dd/MM/yyyy HH:mm:ss",
			value: dateiniday
		}).dxDateBox('instance');

	var fdata2 = $("#data2").dxDateBox({
			type: "datetime",
			displayFormat: "dd/MM/yyyy HH:mm:ss",
			value: dateendday

		}).dxDateBox('instance');

	var fentitat = $("#TxPlate").dxTextBox();

	$("#radio-group-simple") .dxSelectBox({
        dataSource: new DevExpress.data.ArrayStore({ 
            data: listas,
            key: "ID"
        }),
        displayExpr: "description",
        valueExpr: "ID",
        value: listas[0].ID,
    });
	
	
    
    $("#medium-indicator").dxLoadIndicator({
        height: 40,
        width: 40
    });
	 $("#medium-indicator").hide();
	
	$("#icon-done_info").dxButton({
	
		type: "success",
		height: 40,
		text: DevExpress.localization.formatMessage("Search"),
		onClick: function (data2) {
		
		if(fdata1.option('value') > fdata2.option('value'))
		{
			DevExpress.ui.dialog.alert(DevExpress.localization.formatMessage("The 'from date' can not be greater than  'to date'"));
		}else{
		
			var i = 1;
			var moreparams = "";
			var plate = $('#TxPlate').dxTextBox('instance').option('value');
			var list =$("#radio-group-simple").dxSelectBox('instance').option('value');
			data2.component.option("text", DevExpress.localization.formatMessage("Searching"));
			 $("#medium-indicator").show();
			if (plate != "") {
				moreparams = "&camp" + i + "=numberplate&comp" + i + "=like&value" + i + "=" + plate;
				i++;
			}
			if (list != -2) {
			
				moreparams += "&camp" + i + "=listid&comp" + i + "=equal&value" + i + "=["+list+"]";
				
			}

			$.ajax({
				dataType: "json",
				url: pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=select&table=nlresult&camp0=timestamp&comp0=between&value0=" + getStringNormalDate(fdata1.option('value')) + ";" + getStringNormalDate2(fdata2.option('value')) + moreparams + "&maxvalues=1000&date="+ getStringNormalDate(new Date()),
				success: function (data) {
				
					data2.component.option("text", DevExpress.localization.formatMessage("Search"));
					$("#medium-indicator").hide();
					var dataGrid = $('#gridContainer').dxDataGrid('instance');
					dataGrid.option("dataSource", data);
				}
			});
		
			}
		}

	});

	$("#gridContainer").dxDataGrid({
		dataSource: results,
		showBorders: true,
		showRowLines: true,
		keyExpr: "id",

		hoverStateEnabled: true,
		paging: {
			pageSize: 10
		},
		searchPanel: {
            visible: true,
            width: 240,
            placeholder: DevExpress.localization.formatMessage("Search...")
        },
		pager: {
			showPageSizeSelector: true,
			allowedPageSizes: [5, 10, 20,50,100],
			showInfo: true
		},
		columns: [{
				dataField: "id",
				caption: "ID",
				width: 80,
			}, {
				dataField: "timestamp",
				dataType: "date",
				caption: DevExpress.localization.formatMessage("Time"),
				width: 180,
				format: "HH:mm:ss.SSS dd/MM/yyyy"
			}, {
				width: 100,
				dataField: "numberplate",
				caption: DevExpress.localization.formatMessage("Plate")
			},
			, {
				width: 80,
				dataField: "laneid",
				caption: DevExpress.localization.formatMessage("Lane"),
				cellTemplate: function (element, info) {
				if(info.text == 0)
				{
					element.append("");
				}
				else{
					if(info.text % 2 == 0)
					{
						element.append(DevExpress.localization.formatMessage("LANE 1"));
					}
					else{
						element.append(DevExpress.localization.formatMessage("LANE 2"));
					}
				}
				
				}
			},			{
				width: 60,
				dataField: "globalconfidence",
				caption: DevExpress.localization.formatMessage("Conf.")
			},
			, {
				width: 100,
				dataField: "country",
				caption: DevExpress.localization.formatMessage("Country"),
				cellTemplate: function (element, info) {
					element.append(dict[info.text]);
				}
			},

			{
				dataField: "listid",
				caption: DevExpress.localization.formatMessage("List"),
				cellTemplate: function (element, info) {

					if (info.text != "[-1]") {
						var listastring = "";
						if (info.text.includes(";")) {

							var listas = info.text.split(";");
							$.each(listas, function (i, item) {
								listastring += dictlist[item] + ";";

							});
							listastring = listastring.slice(0, -1);
						} else {
							listastring = dictlist[info.text];
						}

						element.append(listastring);
					} else {
						element.append("");
					}

				}
			}, {
				dataField: "imageretailpath",
				caption: DevExpress.localization.formatMessage("Image"),
				width: 150,
				cellTemplate: function (element, info) {
				
					if(info.text != "")
					{
						element.append("<img id='img" + info.key + "' src='" + pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=getimage&path=" + info.text + "' height = '20' width='125'><div id='tooltip" + info.key + "'></div>")

						if (info.row.data.imagepath != "") {

						$("#tooltip" + info.key).dxTooltip({
							target: "#img" + info.key,
							showEvent: "mouseenter",
							 hideEvent: "mouseleave",
							
							position: "left",
							contentTemplate: function (data) {
							
								data.html("<canvas id='canvas"+info.key+"' width='800' height='600' ></canvas>");
								var canvas = document.getElementById('canvas' + info.key);
									var ctx = canvas.getContext('2d');

									var tmpImg = new Image();
									tmpImg.src = pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=getimage&path=" + info.row.data.imagepath;
									tmpImg.onload = function () {
									
									    var widthdraw= 800;
										var heightdraw = 600;
										ctx.drawImage(tmpImg, 0, 0, 800, 600);
										ctx.rect(info.row.data.resultleft * (widthdraw /  info.row.data.width),info.row.data.resulttop * (heightdraw / info.row.data.height), (info.row.data.resultright - info.row.data.resultleft) * (widthdraw /  info.row.data.width), (info.row.data.resultbottom - info.row.data.resulttop) * (heightdraw / info.row.data.height));
										ctx.strokeStyle = 'green';
										ctx.lineWidth = 3;
										ctx.stroke();
									}
								
								
								
							}
						});
						}
						
					}
					else{
						element.append(DevExpress.localization.formatMessage("No image"));
					}
					
					

				}
			}
			, {
				dataField: "imagepath",
				caption: DevExpress.localization.formatMessage("Image"),
				width: 150,
				cellTemplate: function (element, info) {
				
					if(info.text != "")
					{
						element.append("<a  href='" + pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=getfile&path=" + info.text + "'>Download image</a>")

					}
					else{
						element.append(DevExpress.localization.formatMessage("No image"));
					}
					
					

				}
			}

		],
		"export": {
			enabled: true,
			fileName: "Export",
			allowExportSelectedData: false,
			printingEnabled: true,
			customizeExcelCell: function(e) {
                if(e.gridCell.rowType === 'data') {
                    if( !e.gridCell.data.listid.includes("[-1]")) {
                        
                        e.backgroundColor = "#d9534f";
                    }
                
                }
            }
			
			
		},
		customizeExportData: function(cols, rows){
					
					 rows.forEach(function(row){
						var rowValues = row.values;
						
						if(	rowValues[3]==0)
						{
							rowValues[3]="";
						}
						else{
							if(rowValues[3] % 2 == 0)
							{
								rowValues[3]=DevExpress.localization.formatMessage("LANE 1");
							}
							else{
								rowValues[3]=DevExpress.localization.formatMessage("LANE 2");
							}
						}
												
						rowValues[5]=dict[rowValues[5]];
						var listasids = rowValues[6];
						var listastring = "";
						if (listasids != "[-1]") {
							var listastring = "";
							if (listasids.includes(";")) {

								var listas = info.text.split(";");
								$.each(listas, function (i, item) {
									listastring += dictlist[item] + ";";

								});
								listastring = listastring.slice(0, -1);
							} else {
								listastring = dictlist[listasids];
							}

							rowValues[6]=listastring;
						} else {
							rowValues[6]="";
						}
					
					
							
					});
			
		},
		
		onExporting: function(e){
			e.component.beginUpdate();
			e.component.columnOption("imagepath", "visible", false);
			e.component.columnOption("imageretailpath", "visible", false);
		},
		onExported: function(e){
		
			e.component.columnOption("imagepath", "visible", true);
			e.component.columnOption("imageretailpath", "visible", true);
			e.component.endUpdate();
		},
		onRowPrepared: function (row) {
			if (row.rowType == "data") {
				if (row.values[6] != "[-1]") {

					row.rowElement.addClass('Red');
				}
			}

		}
	});
});
